<template>
  <teleport to="body">
      <div>
        <div v-if="show" @click="tryClose" class="backdrop"></div>
        <transition name="pop-login-modal">
        <dialog open v-if="show">
          <div class="card">
            <h5 class="card-header">{{ title }}</h5>
            <div class="card-body">
              <h5 class="card-title">Enter your login credentials:</h5>
              <form @submit.prevent>
                <div class="form-control">
                  <label for="username">Username: </label>
                  <input type="text" id="username" name="username" v-model="username" @blur="usernameInputValidate">
                  <p class="invalid-form" v-if="!isFormUsernameValid">You must enter a username</p>
                </div>
                <div class="form-control">
                  <label for="password">Password: </label>
                  <input type="password" id="password" name="password" v-model="password" @blur="passwordInputValidate">
                  <p class="invalid-form" v-if="!isFormPasswordValid">You must enter a password</p>
                </div>
                <button type="button" class="btn btn-primary" @click="loginFormSubmit">Log In</button>
              </form>
            </div>
          </div>
        </dialog>
        </transition>
      </div>
  </teleport>
</template>

<script>
export default {
  data() {
    return {
      username: '',
      password: '',
      fixed: false,
      isFormUsernameValid: true,
      isFormPasswordValid: true,
    };
  },
  props: {
    show: {
      type: Boolean,
      required: true,
    },
    title: {
      type: String,
      required: false,
    },
  },
  emits: ['close', 'submit-login'],
  methods: {
    tryClose() {
      // close without logging in - by clicking on backdrop
      if (this.fixed) { // todo - check if this will be used at all
        return;
      }
      this.username = '';
      this.password = '';
      this.isFormUsernameValid = true;
      this.isFormPasswordValid = true;
      this.$emit('close');
    },
    usernameInputValidate() {
      this.isFormUsernameValid = this.username !== '';
    },
    passwordInputValidate() {
      this.isFormPasswordValid = this.password !== '';
    },
    loginFormValidate() {
      this.usernameInputValidate();
      this.passwordInputValidate();
      return this.isFormUsernameValid && this.isFormPasswordValid;
    },
    loginFormSubmit() {
      // when login form submitted, emit custom event to parent & pack login data as payload
      if (this.loginFormValidate()) {
        this.$emit('submit-login', {
          username: this.username,
          password: this.password,
        });
        this.username = '';
        this.password = '';
      }
    },
  },
};
</script>

<style scoped>
.backdrop {
  position: fixed;
  top: 0;
  left: 0;
  height: 100vh;
  width: 100%;
  background-color: rgba(0, 0, 0, 0.75);
  z-index: 10;
}

dialog {
  position: fixed;
  top: 20vh;
  left: 10%;
  width: 80%;
  z-index: 100;
  border-radius: 12px;
  border: none;
  box-shadow: 0 2px 8px rgba(0, 0, 0, 0.26);
  padding: 0;
  margin: 0;
  overflow: hidden;
  background-color: white;
}

.invalid-form {
  color: red;
}

.pop-login-modal-enter-from {
  opacity: 0;
  transform: translateY(-40px);
}

.pop-login-modal-enter-to {
  opacity: 1;
  transform: translateY(0);
}

.pop-login-modal-enter-active {
  transition: all 0.4s ease-out;
}

.pop-login-modal-leave-from {
  opacity: 1;
  transform: translateY(0);
}

.pop-login-modal-leave-to {
  opacity: 0;
  transform: translateY(-40px);
}

.pop-login-modal-leave-active {
  transition: all 0.3s ease-in;
}

@media (min-width: 768px) {
  dialog {
    left: calc(50% - 20rem);
    width: 40rem;
  }
}
</style>
